
Redmine - Defect #4924

mercurial reader disregard information from non-default branch

2010-02-24 22:54 - Thomas Capricelli

Status: Closed Start date: 2010-02-24

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version:  

Description

It took me a while to understand why the bug were not closed in my redmine instance... The problem is that the mercurial SCM stuff

only reads information that are on the main branch ("named branches" in mercurial terminology). As a result, changes on other

branches are not available:

on the file browser (this is ok)

in the history of each file (not good)

in the global history at the bottom of the /projects/xxx/repository/ page (not good)

automatic fixes of tickets using "fixes #xx" is not done (not good, especially when the non-default branch is a stable one..)

My repository layout is simple:

% hg branches

branch-1.0                  1300:267cf8a7e905

default                     1298:a00cb05dd3d2

Related issues:

Related to Redmine - Defect #3724: Mercurial repositories display revision ID... Closed 2009-08-10

Related to Redmine - Feature #7246: Handle "named branch" for mercurial Closed 2011-01-07

History

#1 - 2010-03-11 11:39 - Toshi MARUYAMA

- % Done changed from 0 to 90

Please see #4455 - Mercurial overhaul.

#2 - 2010-03-12 15:10 - Toshi MARUYAMA

- % Done changed from 90 to 0

Sorry, This issue is "main" and "stable" repository problem.

I think this issue is related #779.

#3 - 2010-03-12 15:25 - Toshi MARUYAMA

Simple solution is to prepare "main + stable" repository.

http://mercurial.selenic.com/wiki/DeveloperRepos

http://hg.intevation.org/mercurial/crew+main

automatic mix of crew and main (may contain multiple heads)

#4 - 2011-01-07 12:58 - Toshi MARUYAMA

- Status changed from New to Closed

Description seems like you did history editing, "hg strip", "hg rebase" etc.

Mercurial revision number is sequential from 0 and Redmine 1.1 does not treat Mercurial "named branch".

We will fix inconsistency with Mercurial repository and database at #3724.

But, if you did history editing, you need to delete repository and re-add it at Redmine setting.

And we will support a feature of Mercurial "named branch".
I close this issue.

#5 - 2011-01-07 13:27 - Thomas Capricelli

I did not edit history, not even a rebase. I know that i need to delete/readd the repository if i did. (i have done this several times on other projects).

No, the problem is that 'named branch' were not seen by mercurial, which you seem to acknowledge/agree.

I already follow the ticket #3724 (using revision id instead of changeset seemed so wrong to me...).

So what you say is that you will do it in the future, but you already close my ticket..? This seems a weird approach of project management.... ?

Shouldn't the ticket be closed only when the actual modification has been made ?

Anyway, thanks for taking care of improving mercurial support in redmine, this is needed.

#6 - 2011-01-07 14:01 - Toshi MARUYAMA

Thank you for your reply.

Now I clean up mercurial issues on Redmine for JPL's suggestion at note-199 of #4455.

"Named branch" support is feature issue.

There is "tag" feature issue at #1981.

But, there is not "Named branch".

Could you create new feature issue for "Named branch"?

#7 - 2011-01-07 14:35 - Thomas Capricelli

Ok, i created #7246 and assigned it to you. I hope i did well.

#8 - 2011-01-07 14:50 - Toshi MARUYAMA

- File TortoiseHg-default.png added

- File TortoiseHg-stable.png added

- File thg-history.png added

I attach TortoiseHg repository images.

TortoiseHg has two named branches.

Now stable is 1.1.x, default is 1.9.x.

"thg" is only in default branch.

$ LANG=C hg branches

default                     9824:493a9d3809e9

stable                      9818:66fb6e2ff598 (inactive)

$ LANG=C hg heads

changeset:   9824:493a9d3809e9

tag:         tip

user:        Steve Borho <XXXXXXXXXXXXXXXX>

date:        Thu Jan 06 23:39:14 2011 -0600

summary:     thgrepo: repository locks are symlinks to non-existant files

changeset:   9818:66fb6e2ff598

branch:      stable

parent:      9790:5fa3912d3563

user:        Steve Borho <XXXXXXXXXXXXXXXXX>

date:        Wed Jan 05 21:43:41 2011 -0600

summary:     thread: improve SSL error messages

#9 - 2011-01-07 15:01 - Toshi MARUYAMA

Thomas Capricelli wrote:

Ok, i created #7246 and assigned it to you. I hope i did well.

 Thank you.

Files

TortoiseHg-default.png 122 KB 2011-01-07 Toshi MARUYAMA

TortoiseHg-stable.png 124 KB 2011-01-07 Toshi MARUYAMA
